Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4848)
@@ -1,3 +1,4 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
+
 # ----------------------------------------------------------------------
 #  COMPONENT: nanovisviewer - 3D volume rendering
@@ -75,93 +76,78 @@
     public method isconnected {}
     public method limits { tf }
+    public method overmarker { m x }
     public method parameters {title args} { 
         # do nothing 
     }
+    public method rmdupmarker { m x }
     public method scale {args}
-    public method updateTransferFunctions {}
+    public method updatetransferfuncs {}
+
+    protected method Connect {}
+    protected method CurrentDatasets {{what -all}}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method FixLegend {}
+    protected method AdjustSetting {what {value ""}}
+    protected method InitSettings { args }
+    protected method Pan {option x y}
+    protected method Rebuild {}
+    protected method ReceiveData { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { tf vmin vmax size }
+    protected method Rotate {option x y}
+    protected method SendTransferFuncs {}
+    protected method Slice {option args}
+    protected method SlicerTip {axis}
+    protected method Zoom {option}
 
     # The following methods are only used by this class.
-
-    private method AddNewMarker { x y } 
-    private method AdjustSetting {what {value ""}}
+    private method AddIsoMarker { x y }
     private method BuildCameraTab {}
     private method BuildCutplanesTab {}
     private method BuildViewTab {}
-    private method BuildVolumeComponents {}
     private method BuildVolumeTab {}
-    private method ComputeAlphamap { cname } 
-    private method ComputeTransferFunction { cname }
-    private method Connect {}
-    private method CurrentDatasets {{what -all}}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DrawLegend { cname }
-    private method EventuallyRedrawLegend { } 
+    private method ResetColormap { color }
+    private method ComputeTransferFunc { tf }
     private method EventuallyResize { w h } 
-    private method FixLegend {}
-    private method GetAlphamap { cname color } 
-    private method GetColormap { cname color } 
-    private method GetDatasetsWithComponent { cname } 
+    private method EventuallyResizeLegend { } 
+    private method NameTransferFunc { dataobj comp }
+    private method PanCamera {}
+    private method ParseLevelsOption { tf levels }
+    private method ParseMarkersOption { tf markers }
+    private method volume { tag name }
     private method GetVolumeInfo { w }
-    private method HideAllMarkers {} 
-    private method InitComponentSettings { cname } 
-    private method InitSettings { args }
-    private method NameToAlphamap { name } 
-    private method NameTransferFunction { dataobj comp }
-    private method Pan {option x y}
-    private method PanCamera {}
-    private method ParseLevelsOption { cname levels }
-    private method ParseMarkersOption { cname markers }
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveData { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { tf vmin vmax size }
-    private method RemoveMarker { x y }
-    private method ResetColormap { cname color }
-    private method Rotate {option x y}
-    private method SendTransferFunctions {}
-    private method SetObjectStyle { dataobj cname }
     private method SetOrientation { side }
-    private method Slice {option args}
-    private method SlicerTip {axis}
-    private method SwitchComponent { cname } 
-    private method ToggleVolume { tag name }
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
 
     private variable _dlist ""     ;# list of data objects
+    private variable _allDataObjs
     private variable _obj2ovride   ;# maps dataobj => style override
     private variable _serverDatasets   ;# contains all the dataobj-component 
                                    ;# to volumes in the server
-    private variable _recvdDatasets;    # list of data objs to send to server
-    private variable _dataset2style;    # maps dataobj-component to transfunc
-    private variable _style2datasets;   # maps tf back to list of 
-                                        # dataobj-components using the tf.
-
-    private variable _reset 1;		# Connection to server has been reset.
-    private variable _click;            # Info used for rotate operations.
-    private variable _limits;           # Autoscale min/max for all axes
-    private variable _view;             # View params for 3D view
-    private variable _parsedFunction
-    private variable _transferFunctionEditors
-    private variable _settings
-    private variable _widget
-
-    private variable _first "" ;        # This is the topmost volume.
-    private variable _current "";       # Currently selected component 
-    private variable _volcomponents   ; # Array of components found 
-    private variable _componentsList   ; # Array of components found 
-    private variable _cname2style
-    private variable _cname2transferFunction
-    private variable _cname2defaultcolormap
-    private variable _cname2defaultalphamap
-
+    private variable _serverTfs    ;# contains all the transfer functions 
+                                   ;# in the server.
+    private variable _recvdDatasets    ;# list of data objs to send to server
+    private variable _dataset2style    ;# maps dataobj-component to transfunc
+    private variable _style2datasets   ;# maps tf back to list of 
+                                    # dataobj-components using the tf.
+
+    private variable _reset 1;		# Connection to server has been reset 
+    private variable _click        ;# info used for rotate operations
+    private variable _limits       ;# autoscale min/max for all axes
+    private variable _view         ;# view params for 3D view
+    private variable _isomarkers    ;# array of isosurface level values 0..1
+    private variable  _settings
+    # Array of transfer functions in server.  If 0 the transfer has been
+    # defined but not loaded.  If 1 the transfer function has been named
+    # and loaded.
+    private variable _activeTfs
+    private variable _first ""     ;# This is the topmost volume.
+
+    # This 
+    # indicates which isomarkers and transfer
+    # function to use when changing markers,
+    # opacity, or thickness.
     common _downloadPopup          ;# download options from popup
     private common _hardcopy
@@ -190,5 +176,5 @@
     $_dispatcher register !send_transfunc
     $_dispatcher dispatch $this !send_transfunc \
-        "[itcl::code $this SendTransferFunctions]; list"
+        "[itcl::code $this SendTransferFuncs]; list"
 
     # Rebuild event
@@ -209,50 +195,37 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -qw      0.853553
-        -qx      -0.353553
-        -qy      0.353553
-        -qz      0.146447
-        -xpan    0
-        -ypan    0
-        -zoom    1.0
+        qw      0.853553
+        qx      -0.353553
+        qy      0.353553
+        qz      0.146447
+        zoom    1.0
+        xpan    0
+        ypan    0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
-
-    set _limits(v) [list 0.0 1.0]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
+
+    set _limits(vmin) 0.0
+    set _limits(vmax) 1.0
     set _reset 1
 
-    array set _settings {
-        -axesvisible            1
-        -background             black
-        -colormap               "default"
-        -cutplanesvisible       0
-        -gridvisible            0
-        -isosurfaceshading      0
-        -legendvisible          1
-        -light                  40
-        -light2side             1
-        -outlinevisible         0
-        -qw                     0.853553
-        -qx                     -0.353553
-        -qy                     0.353553
-        -qz                     0.146447
-        -thickness              350
-        -volume                 1
-        -volumeopacity          0.5
-        -volumevisible          1
-        -xcutplaneposition      50
-        -xcutplanevisible       1
-        -xpan                   0
-        -ycutplaneposition      50
-        -ycutplanevisible       1
-        -ypan                   0
-        -zcutplaneposition      50
-        -zcutplanevisible       1
-        -zoom                   1.0
-    }
-    array set _widget {
-        -volumeopacity          50
-    }
+    array set _settings [subst {
+        $this-qw                $_view(qw)
+        $this-qx                $_view(qx)
+        $this-qy                $_view(qy)
+        $this-qz                $_view(qz)
+        $this-zoom              $_view(zoom)    
+        $this-xpan              $_view(xpan)
+        $this-ypan              $_view(ypan)
+        $this-volume            1
+        $this-xcutplane         0
+        $this-xcutposition      0
+        $this-ycutplane         0
+        $this-ycutposition      0
+        $this-zcutplane         0
+        $this-zcutposition      0
+    }]
+
     itk_component add 3dview {
         label $itk_component(plotarea).view -image $_image(plot) \
@@ -275,6 +248,5 @@
     }
     pack $itk_component(reset) -side top -padx 2 -pady 2
-    Rappture::Tooltip::for $itk_component(reset) \
-        "Reset the view to the default zoom level"
+    Rappture::Tooltip::for $itk_component(reset) "Reset the view to the default zoom level"
 
     itk_component add zoomin {
@@ -306,6 +278,6 @@
             -onimage [Rappture::icon volume-on] \
             -offimage [Rappture::icon volume-off] \
-            -command [itcl::code $this AdjustSetting -volume] \
-            -variable [itcl::scope _settings(-volume)]
+            -command [itcl::code $this AdjustSetting volume] \
+            -variable [itcl::scope _settings($this-volume)]
     }
     $itk_component(volume) select
@@ -313,15 +285,4 @@
         "Toggle the volume cloud on/off"
     pack $itk_component(volume) -padx 2 -pady 2
-
-    itk_component add cutplane {
-        Rappture::PushButton $f.cutplane \
-            -onimage [Rappture::icon cutbutton] \
-            -offimage [Rappture::icon cutbutton] \
-            -variable [itcl::scope _settings(-cutplanesvisible)] \
-            -command [itcl::code $this AdjustSetting -cutplanesvisible] 
-    }
-    Rappture::Tooltip::for $itk_component(cutplane) \
-        "Show/Hide cutplanes"
-    pack $itk_component(cutplane) -padx 2 -pady 2
 
     if { [catch {
@@ -336,4 +297,5 @@
 
     # Legend
+
     set _image(legend) [image create photo]
     itk_component add legend {
@@ -345,9 +307,5 @@
     }
     bind $itk_component(legend) <Configure> \
-        [itcl::code $this EventuallyRedrawLegend]
-    bind $itk_component(legend) <KeyPress-Delete> \
-        [itcl::code $this RemoveMarker %x %y]
-    bind $itk_component(legend) <Enter> \
-        [list focus $itk_component(legend)]
+        [itcl::code $this EventuallyResizeLegend]
 
     # Hack around the Tk panewindow.  The problem is that the requested 
@@ -428,9 +386,6 @@
     image delete $_image(legend)
     image delete $_image(download)
-    foreach name [array names _transferFunctionEditors] {
-        itcl::delete object $_transferFunctionEditors($cname)
-    }
     catch { blt::arcball destroy $_arcball }
-    array unset _settings 
+    array unset _settings $this-*
 }
 
@@ -464,4 +419,5 @@
     if {$pos < 0} {
         lappend _dlist $dataobj
+        set _allDataObjs($dataobj) 1
         set _obj2ovride($dataobj-color) $params(-color)
         set _obj2ovride($dataobj-width) $params(-width)
@@ -540,6 +496,6 @@
         if { $pos >= 0 } {
             set _dlist [lreplace $_dlist $pos $pos]
+            array unset _limits $dataobj*
             array unset _obj2ovride $dataobj-*
-            array unset _dataset2style $dataobj-*
             set changed 1
         }
@@ -561,47 +517,28 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::NanovisViewer::scale {args} {
-    array set styles {
-        -color    BCGYR
-        -levels   6
-        -markers  ""
-    }
-    array unset _limits 
-    array unset _volcomponents 
+    foreach val {xmin xmax ymin ymax zmin zmax vmin vmax} {
+        set _limits($val) ""
+    }
     foreach dataobj $args {
         if { ![$dataobj isvalid] } {
             continue;                     # Object doesn't contain valid data.
         }
-        foreach cname [$dataobj components] {
-            if { ![info exists _volcomponents($cname)] } {
-                lappend _componentsList $cname
-                array set styles [lindex [$dataobj components -style $cname] 0]
-                set cmap [ColorsToColormap $styles(-color)]
-                set _cname2defaultcolormap($cname) $cmap
-                set _settings($cname-colormap) $styles(-color)
-            }
-            lappend _volcomponents($cname) $dataobj-$cname
-            array unset limits
-            array set limits [$dataobj valueLimits $cname]
-            set _limits($cname) $limits(v)
-        }
         foreach axis {x y z v} {
             foreach { min max } [$dataobj limits $axis] break
             if {"" != $min && "" != $max} {
-                if { ![info exists _limits($axis)] } {
-                    set _limits($axis) [list $min $max]
+                if {"" == $_limits(${axis}min)} {
+                    set _limits(${axis}min) $min
+                    set _limits(${axis}max) $max
                 } else {
-                    foreach {amin amax} $_limits($axis) break
-                    if {$min < $amin} {
-                        set amin $min
+                    if {$min < $_limits(${axis}min)} {
+                        set _limits(${axis}min) $min
                     }
-                    if {$max > $amax} {
-                        set amax $max
+                    if {$max > $_limits(${axis}max)} {
+                        set _limits(${axis}max) $max
                     }
-                    set _limits($axis) [list $amin $amax]
                 }
             }
         }
     }
-    BuildVolumeComponents
 }
 
@@ -666,5 +603,5 @@
         if { $_reportClientInfo }  {
             # Tell the server the viewer, hub, user and session.
-            # Do this immediately on connect before buffering any commands
+            # Do this immediately on connect before buffing any commands
             global env
 
@@ -726,9 +663,41 @@
 
 # ----------------------------------------------------------------------
-# USAGE: SendTransferFunctions
-# ----------------------------------------------------------------------
-itcl::body Rappture::NanovisViewer::SendTransferFunctions {} {
-    foreach cname [array names _volcomponents] {
-        ComputeTransferFunction $cname
+# USAGE: SendTransferFuncs
+# ----------------------------------------------------------------------
+itcl::body Rappture::NanovisViewer::SendTransferFuncs {} {
+    if { $_first == "" } {
+        puts stderr "first not set"
+        return
+    }
+    # Ensure that the global opacity and thickness settings (in the slider
+    # settings widgets) are used for the active transfer-function.  Update
+    # the values in the _settings varible.
+    set opacity [expr { double($_settings($this-opacity)) * 0.01 }]
+    # Scale values between 0.00001 and 0.01000
+    set thickness [expr {double($_settings($this-thickness)) * 0.0001}]
+
+    foreach tag [CurrentDatasets] {
+        if { ![info exists _serverDatasets($tag)] || !$_serverDatasets($tag) } {
+            # The volume hasn't reached the server yet.  How did we get 
+            # here?
+            puts stderr "Don't have $tag in _serverDatasets"
+            continue
+        }
+        if { ![info exists _dataset2style($tag)] } {
+            puts stderr "don't have style for volume $tag"
+            continue;                        # How does this happen?
+        }
+        set tf $_dataset2style($tag)
+        set _settings($this-$tf-opacity) $opacity
+        set _settings($this-$tf-thickness) $thickness
+        ComputeTransferFunc $tf
+        # FIXME: Need to the send information as to what transfer functions
+        #        to update so that we only update the transfer function 
+        #        as necessary.  Right now, all transfer functions are 
+        #        updated. This makes moving the isomarker slider chunky.
+        if { ![info exists _activeTfs($tf)] || !$_activeTfs($tf) } {
+            set _activeTfs($tf) 1
+        }
+        SendCmd "volume shading transfunc $tf $tag"
     }
     FixLegend
@@ -761,7 +730,24 @@
 
 #
-# DrawLegend --
-#
-itcl::body Rappture::NanovisViewer::DrawLegend { cname } {
+# ReceiveLegend --
+#
+#       The procedure is the response from the render server to each "legend"
+#       command.  The server sends back a "legend" command invoked our
+#       the slave interpreter.  The purpose is to collect data of the image 
+#       representing the legend in the canvas.  In addition, the isomarkers
+#       of the active transfer function are displayed.
+#
+#       I don't know is this is the right place to display the isomarkers.
+#       I don't know all the different paths used to draw the plot. There's 
+#       "Rebuild", "add", etc.
+#
+itcl::body Rappture::NanovisViewer::ReceiveLegend { tf vmin vmax size } {
+    if { ![isconnected] } {
+        return
+    }
+    set bytes [ReceiveBytes $size]
+    $_image(legend) configure -data $bytes
+    ReceiveEcho <<line "<read $size bytes for [image width $_image(legend)]x[image height $_image(legend)] legend>"
+
     set c $itk_component(legend)
     set w [winfo width $c]
@@ -769,61 +755,47 @@
     set lx 10
     set ly [expr {$h - 1}]
-    if {"" == [$c find withtag colorbar]} {
+    if {"" == [$c find withtag transfunc]} {
         $c create image 10 10 -anchor nw \
-            -image $_image(legend) -tags colorbar
+            -image $_image(legend) -tags transfunc
         $c create text $lx $ly -anchor sw \
-            -fill $itk_option(-plotforeground) -tags "limits text vmin"
+            -fill $itk_option(-plotforeground) -tags "limits vmin"
         $c create text [expr {$w-$lx}] $ly -anchor se \
-            -fill $itk_option(-plotforeground) -tags "limits text vmax"
-        $c create text [expr {$w/2}] $ly -anchor s \
-            -fill $itk_option(-plotforeground) -tags "limits text title"
-        $c lower colorbar
-        $c bind colorbar <ButtonRelease-1> [itcl::code $this AddNewMarker %x %y]
-    }
-
-    # Display the markers used by the current transfer function.
-    HideAllMarkers
-    $_transferFunctionEditors($cname) showMarkers $_limits($cname)
-
-    foreach {min max} $_limits($cname) break
-    $c itemconfigure vmin -text [format %g $min]
+            -fill $itk_option(-plotforeground) -tags "limits vmax"
+        $c lower transfunc
+        $c bind transfunc <ButtonRelease-1> \
+            [itcl::code $this AddIsoMarker %x %y]
+    }
+    # Display the markers used by the active transfer function.
+
+    array set limits [limits $tf]
+    $c itemconfigure vmin -text [format %.2g $limits(min)]
     $c coords vmin $lx $ly
 
-    $c itemconfigure vmax -text [format %g $max]
+    $c itemconfigure vmax -text [format %.2g $limits(max)]
     $c coords vmax [expr {$w-$lx}] $ly
 
-    set title [$_first hints label]
-    set units [$_first hints units]
-    if { $units != "" } {
-        set title "$title ($units)"
-    }
-    $c itemconfigure title -text $title
-    $c coords title [expr {$w/2}] $ly
+    if { [info exists _isomarkers($tf)] } {
+        foreach m $_isomarkers($tf) {
+            $m visible yes
+        }
+    }
 
     # The colormap may have changed. Resync the slicers with the colormap.
-    InitSettings -cutplanesvisible -xcutplanevisible -ycutplanevisible \
-        -zcutplanevisible 
-}
-
-#
-#
-# ReceiveLegend --
-#
-#       The procedure is the response from the render server to each "legend"
-#       command.  The server sends back a "legend" command invoked our
-#       the slave interpreter.  The purpose is to collect data of the image 
-#       representing the legend in the canvas.  In addition, the
-#       active transfer function is displayed.
-#
-#
-itcl::body Rappture::NanovisViewer::ReceiveLegend { cname vmin vmax size } {
-    if { ![isconnected] } {
-        return
-    }
-    set bytes [ReceiveBytes $size]
-    $_image(legend) configure -data $bytes
-    ReceiveEcho <<line "<read $size bytes for [image width $_image(legend)]x[image height $_image(legend)] legend>"
-
-    DrawLegend $_current
+    set datasets [CurrentDatasets -cutplanes]
+    SendCmd "volume data state $_settings($this-volume) $datasets"
+
+    # Adjust the cutplane for only the first component in the topmost volume
+    # (i.e. the first volume designated in the field).
+    set tag [lindex $datasets 0]
+    foreach axis {x y z} {
+        # Turn off cutplanes for all volumes
+        SendCmd "cutplane state 0 $axis"
+        if { $_settings($this-${axis}cutplane) } {
+            # Turn on cutplane for this particular volume and set the position
+            SendCmd "cutplane state 1 $axis $tag"
+            set pos [expr {0.01*$_settings($this-${axis}cutposition)}]
+            SendCmd "cutplane position $pos $axis $tag"
+        }
+    }
 }
 
@@ -865,13 +837,18 @@
     set dataobj [lindex $parts 0]
     set _serverDatasets($tag) 1
-    if { $_settings(-volumevisible) && $dataobj == $_first } {
+    if { $_settings($this-volume) && $dataobj == $_first } {
         SendCmd "volume state 1 $tag"
     }
-    set _limits($tag) [list $info(min)  $info(max)]
-    set _limits(v)    [list $info(vmin) $info(vmax)]
+    set _limits($tag-min)  $info(min);  # Minimum value of the volume.
+    set _limits($tag-max)  $info(max);  # Maximum value of the volume.
+    set _limits(vmin)      $info(vmin); # Overall minimum value.
+    set _limits(vmax)      $info(vmax); # Overall maximum value.
 
     unset _recvdDatasets($tag)
     if { [array size _recvdDatasets] == 0 } {
-        updateTransferFunctions
+        # The active transfer function is by default the first component of
+        # the first data object.  This assumes that the data is always
+        # successfully transferred.
+        updatetransferfuncs
     }
 }
@@ -897,4 +874,13 @@
     StartBufferingCommands
 
+    # Hide all the isomarkers. Can't remove them. Have to remember the
+    # settings since the user may have created/deleted/moved markers.
+
+    foreach tf [array names _isomarkers] {
+        foreach m $_isomarkers($tf) {
+            $m visible no
+        }
+    }
+
     if { $_width != $w || $_height != $h || $_reset } {
         set _width $w
@@ -903,5 +889,4 @@
         DoResize
     }
-
     foreach dataobj [get] {
         foreach cname [$dataobj components] {
@@ -913,11 +898,10 @@
                         puts stderr "??? $dataobj is invalid"
                     }
-                    set data [$dataobj blob $cname]
+                    set data [$dataobj values $cname]
                 } else {
                     set data [$dataobj vtkdata $cname]
                     if 0 {
                         set f [open "/tmp/volume.vtk" "w"]
-                        fconfigure $f -translation binary -encoding binary
-                        puts -nonewline $f $data
+                        puts $f $data
                         close $f
                     }
@@ -941,11 +925,7 @@
                 set _serverDatasets($tag) 0
             }
-            SetObjectStyle $dataobj $cname
-        }
-    }
-
-    # Outline seems to need to be reset every update.
-    InitSettings -outlinevisible -cutplanesvisible -current
-
+            NameTransferFunc $dataobj $cname
+        }
+    }
     set _first [lindex [get] 0]
     if { $_reset } {
@@ -953,28 +933,24 @@
 	# Reset the camera and other view parameters
 	#
-        set _settings(-qw)    $_view(-qw)
-        set _settings(-qx)    $_view(-qx)
-        set _settings(-qy)    $_view(-qy)
-        set _settings(-qz)    $_view(-qz)
-	set _settings(-xpan)  $_view(-xpan)
-	set _settings(-ypan)  $_view(-ypan)
-	set _settings(-zoom)  $_view(-zoom)
-
-        set q [ViewToQuaternion]
+        set _settings($this-qw)    $_view(qw)
+        set _settings($this-qx)    $_view(qx)
+        set _settings($this-qy)    $_view(qy)
+        set _settings($this-qz)    $_view(qz)
+	set _settings($this-xpan)  $_view(xpan)
+	set _settings($this-ypan)  $_view(ypan)
+	set _settings($this-zoom)  $_view(zoom)
+
+        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
         $_arcball quaternion $q
         SendCmd "camera orient $q"
         SendCmd "camera reset"
 	PanCamera
-	SendCmd "camera zoom $_view(-zoom)"
+	SendCmd "camera zoom $_view(zoom)"
+        InitSettings light2side light transp isosurface grid axes 
 	
-        #cutplane state 0 all
         foreach axis {x y z} {
             # Turn off cutplanes for all volumes
             SendCmd "cutplane state 0 $axis"
         }
-
-        InitSettings -light2side -light -volumeopacity \
-            -isosurfaceshading -gridvisible -axesvisible \
-
 	if {"" != $_first} {
 	    set axis [$_first hints updir]
@@ -988,5 +964,6 @@
 	}
     }
-
+    # Outline seems to need to be reset every update.
+    InitSettings outline
     # nothing to send -- activate the proper ivol
     SendCmd "volume state 0"
@@ -1000,5 +977,5 @@
         set cname [lindex [$_first components] 0]
         if { [info exists _serverDatasets($_first-$cname)] } {
-            updateTransferFunctions
+            updatetransferfuncs
         }
     }
@@ -1026,9 +1003,9 @@
         set tag $_first-$cname
         if { [info exists _serverDatasets($tag)] && $_serverDatasets($tag) } {
-            array set styles {
+            array set style {
                 -cutplanes 1
             }
-            array set styles [lindex [$_first components -style $cname] 0]
-            if { $what != "-cutplanes" || $styles(-cutplanes) } {
+            array set style [lindex [$_first components -style $cname] 0]
+            if { $what != "-cutplanes" || $style(-cutplanes) } {
                 lappend rlist $tag
             }
@@ -1049,22 +1026,22 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            set _settings(-zoom) $_view(-zoom)
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            set _settings($this-zoom) $_view(zoom)
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            set _settings(-zoom) $_view(-zoom)
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            set _settings($this-zoom) $_view(zoom)
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                qw      0.853553
+                qx      -0.353553
+                qy      0.353553
+                qz      0.146447
+                zoom    1.0
+                xpan   0
+                ypan   0
             }
             if { $_first != "" } {
@@ -1074,15 +1051,15 @@
                 }
             }
-            set q [ViewToQuaternion]          
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
             $_arcball quaternion $q
             SendCmd "camera orient $q"
             SendCmd "camera reset"
-            set _settings(-qw)    $_view(-qw)
-            set _settings(-qx)    $_view(-qx)
-            set _settings(-qy)    $_view(-qy)
-            set _settings(-qz)    $_view(-qz)
-            set _settings(-xpan)  $_view(-xpan)
-            set _settings(-ypan)  $_view(-ypan)
-            set _settings(-zoom)  $_view(-zoom)
+            set _settings($this-qw)    $_view(qw)
+            set _settings($this-qx)    $_view(qx)
+            set _settings($this-qy)    $_view(qy)
+            set _settings($this-qz)    $_view(qz)
+            set _settings($this-xpan)  $_view(xpan)
+            set _settings($this-ypan)  $_view(ypan)
+            set _settings($this-zoom)  $_view(zoom)
         }
     }
@@ -1090,6 +1067,8 @@
 
 itcl::body Rappture::NanovisViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    #set x [expr ($_view(xpan)) / $_limits(xrange)]
+    #set y [expr ($_view(ypan)) / $_limits(yrange)]
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
@@ -1130,9 +1109,9 @@
 
                 set q [$_arcball rotate $x $y $_click(x) $_click(y)]
-                QuaternionToView $q
-                set _settings(-qw) $_view(-qw)
-                set _settings(-qx) $_view(-qx)
-                set _settings(-qy) $_view(-qy)
-                set _settings(-qz) $_view(-qz)
+                foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
+                set _settings($this-qw) $_view(qw)
+                set _settings($this-qx) $_view(qx)
+                set _settings($this-qy) $_view(qy)
+                set _settings($this-qz) $_view(qz)
                 SendCmd "camera orient $q"
 
@@ -1167,9 +1146,9 @@
         set x [expr $x / double($w)]
         set y [expr $y / double($h)]
-        set _view(-xpan) [expr $_view(-xpan) + $x]
-        set _view(-ypan) [expr $_view(-ypan) + $y]
+        set _view(xpan) [expr $_view(xpan) + $x]
+        set _view(ypan) [expr $_view(ypan) + $y]
         PanCamera
-        set _settings(-xpan) $_view(-xpan)
-        set _settings(-ypan) $_view(-ypan)
+        set _settings($this-xpan) $_view(xpan)
+        set _settings($this-ypan) $_view(ypan)
         return
     }
@@ -1184,9 +1163,9 @@
         set _click(x) $x
         set _click(y) $y
-        set _view(-xpan) [expr $_view(-xpan) - $dx]
-        set _view(-ypan) [expr $_view(-ypan) - $dy]
+        set _view(xpan) [expr $_view(xpan) - $dx]
+        set _view(ypan) [expr $_view(ypan) - $dy]
         PanCamera
-        set _settings(-xpan) $_view(-xpan)
-        set _settings(-ypan) $_view(-ypan)
+        set _settings($this-xpan) $_view(xpan)
+        set _settings($this-ypan) $_view(ypan)
     }
     if { $option == "release" } {
